Package net.sf.saxon.om

## Interface SequenceIterator

- All Superinterfaces:
    `java.lang.AutoCloseable`, `java.io.Closeable`
  All Known Subinterfaces:
    `AtomicIterator<T>`, `AtomizedValueIterator`, `AxisIterator`, `ConstrainedIterator<T>`, `FocusIterator`, `GroundedIterator`, `GroupIterator`, `LookaheadIterator`, `RegexIterator`, `ReversibleIterator`, `UnfailingIterator`
  All Known Implementing Classes:
    `AdjacentTextNodeMergingIterator`, `AncestorIterator`, `ARegexIterator`, `ArrayIterator`, `ArrayIterator.OfNodes`, `ATokenIterator`, `AtomizingIterator`, `AttributeIterator`, `AxiomDocument.FollowingSiblingIterator`, `AxiomDocument.PrecedingSiblingIterator`, `AxiomDocumentNodeWrapper.FollowingSiblingIterator`, `AxiomDocumentNodeWrapper.PrecedingSiblingIterator`, `AxiomParentNodeWrapper.ChildWrappingIterator`, `AxiomParentNodeWrapper.DescendantWrappingIterator`, `AxisAtomizingIterator`, `BigRangeIterator`, `BlockIterator`, `CardinalityCheckingIterator`, `CompiledBlockIterator`, `CompiledFilterIterator`, `ConcatenatingAxisIterator`, `ContextMappingIterator`, `DifferenceEnumeration`, `DistinctValues.DistinctIterator`, `DocumentOrderIterator`, `EmptyIterator`, `ErrorIterator`, `FilterIterator`, `FilterIterator.NonNumeric`, `FocusTrackingIterator`, `GroupAdjacentIterator`, `GroupByIterator`, `GroupByIterator.ManualGroupByIterator`, `GroupEndingIterator`, `GroupMatchingIterator`, `GroupStartingIterator`, `HomogeneityCheckerIterator`, `InsertBefore.InsertIterator`, `IntersectionEnumeration`, `ItemMappingIterator`, `IteratorWrapper`, `JRegexIterator`, `JTokenIterator`, `ListIterator`, `ListIterator.Atomic`, `ListIterator.OfNodes`, `LookaheadIteratorImpl`, `ManualGroupIterator`, `ManualIterator`, `ManualRegexIterator`, `MappingIterator`, `MemoSequence.ProgressiveIterator`, `MergeGroupingIterator`, `MergeGroupingIterator.ManualMergeGroupingIterator`, `MergeIterator`, `MultiIndex.SelectedItemsIterator`, `MultithreadedContextMappingIterator`, `MultithreadedFocusTrackingIterator`, `MultithreadedItemMappingIterator`, `Navigator.AncestorEnumeration`, `Navigator.AxisFilter`, `Navigator.DescendantEnumeration`, `Navigator.EmptyTextFilter`, `Navigator.FollowingEnumeration`, `Navigator.PrecedingEnumeration`, `NodeWrappingAxisIterator`, `OneToOneMappingIterator`, `PrependAxisIterator`, `PrependSequenceIterator`, `RangeIterator`, `Remove.RemoveIterator`, `ReturnClauseIterator`, `ReverseListIterator`, `ReverseRangeIterator`, `SingleAtomicIterator`, `SingleNodeIterator`, `SingletonIterator`, `SortedGroupIterator`, `SortedIterator`, `SteppingNavigator.DescendantAxisIterator`, `StringValue.CharacterIterator`, `StringValue.UnicodeCharacterIterator`, `SubsequenceIterator`, `TailIterator`, `TextLinesIterator`, `UnionEnumeration`, `UnionIterator`, `UnparsedTextIterator`, `UntypedAtomizingIterator`, `ValueTailIterator`, `VirtualCopy.VirtualCopier`, `Whitespace.Tokenizer`, `WrappingIterator`

      public interface SequenceIterator
      extends java.io.Closeable

  A SequenceIterator is used to iterate over any XPath 2 sequence (of values or nodes). To get the next item in a sequence, call next(); if this returns null, you've reached the end of the sequence.

  The objects returned by the SequenceIterator will generally be either nodes (class NodeInfo), singleton values (class AtomicValue), or function items: these are represented collectively by the interface `Item`.

  The interface to SequenceIterator is changed in Saxon 9.6 to drop support for the current() and position() methods. Internal iterators no longer need to maintain the values of the current item or the current position. This information is needed (in general) only for an iterator that acts as the current focus; that is, an iterator stored as the current iterator in an XPathContext. SequenceIterators than maintain the value of position() and last() are represented by the interface `FocusIterator`.

  Since:
    8.4. Significant changes in 9.6. Generics added in 9.9, removed again in 10.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `SequenceIterator.Property` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default void` | `close()` | Close the iterator.
    `default void` | `forEachOrFail​(ItemConsumer<? super Item> consumer)` | Process all the remaining items delivered by the SequenceIterator using a supplied consumer function.
    `default java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator.
    `default GroundedValue` | `materialize()` | Create a GroundedValue (a sequence materialized in memory) containing all the values delivered by this SequenceIterator.
    `Item` | `next()` | Get the next item in the sequence.

- - ### Method Detail

    - #### next

          Item next()
             throws XPathException

      Get the next item in the sequence. This method changes the state of the iterator.
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item
      Since:
        8.4

    - #### close

          default void close()

      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      For example, the iterator returned by the unparsed-text-lines() function has a close() method that causes the underlying input stream to be closed, whether or not the file has been read to completion.

      Closing an iterator is important when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Since:
        9.1. Default implementation added in 9.9.

    - #### getProperties

          default java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator.
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the default value `EnumSet.noneOf(Property.class)`, indicating that there are no known special properties. It is acceptable (though unusual) for the properties of the iterator to change depending on its state.
      Since:
        8.6. Default implementation added in 9.9.

    - #### forEachOrFail

          default void forEachOrFail​(ItemConsumer<? super Item> consumer)
                              throws XPathException

      Process all the remaining items delivered by the SequenceIterator using a supplied consumer function.
      Parameters:
        `consumer` - the supplied consumer function
      Throws:
        `XPathException` - if either (a) an error occurs obtaining an item from the input sequence, or (b) the consumer throws an exception.

    - #### materialize

          default GroundedValue materialize()
                                     throws XPathException

      Create a GroundedValue (a sequence materialized in memory) containing all the values delivered by this SequenceIterator. The method must only be used when the SequenceIterator is positioned at the start. If it is not positioned at the start, then it is implementation-dependant whether the returned sequence contains all the nodes delivered by the SequenceIterator from the beginning, or only those delivered starting at the current position.

      It is implementation-dependant whether this method consumes the SequenceIterator. (More specifically, in the current implementation: if the iterator is backed by a `GroundedValue`, then that value is returned and the iterator is not consumed; otherwise, the iterator is consumed and the method returns the remaining items after the current position only).

      Returns:
        a sequence containing all the items delivered by this SequenceIterator.
      Throws:
        `XPathException` - if reading the SequenceIterator throws an error